/*
 * Copyright (c) 2001, Swedish Institute of Computer Science.
 * All rights reserved. 
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met: 
 * 1. Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright 
 *    notice, this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the distribution. 
 * 3. Neither the name of the Institute nor the names of its contributors 
 *    may be used to endorse or promote products derived from this software 
 *    without specific prior written permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE 
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 * SUCH DAMAGE. 
 *
 * This file is part of the lwIP TCP/IP stack.
 * 
 * Author: Adam Dunkels <adam@sics.se>
 *
 * $Id: lib.h,v 1.6 2002/05/23 04:43:57 jctoman Exp $
 */
#ifndef __LIB_H__
#define __LIB_H__

void bcopy(const void *src, void *dest, int len);
void bzero(void *data, int n);

#define bcopy(SRC,DEST,SIZE) memmove(DEST,SRC,SIZE)
#define bzero(SRC,SIZE) memset(SRC,0,SIZE)

#define htons(A) swapuint(A)
#define ntohs(A) swapuint(A)
#define htonl(A) swapulong(A)
#define ntohl(A) swapulong(A)

#define _MACHINE_ENDIAN_H_

#ifdef HTONS
#undef HTONS
#endif HTONS
#define HTONS(n) swapuint(n)

#ifdef NTOHS
#undef NTOHS
#endif NTOHS
#define NTOHS(n) swapuint(n)

#ifdef HTONL
#undef HTONL
#endif HTONL
#define HTONL(n) swapulong(n)

#ifdef NTOHL
#undef NTOHL
#endif NTOHL
#define NTOHL(n) swapulong(n)

#define swapuint(x) _asm( [ _A, _HL ], _HL = (x), "ld a,l", "ld l,h",\
                         "ld h,a", _HL )

#define swapulong(x) _asm( [ _BC, _DE, _HL ], _BCDE = (x),\
                         "ld hl,bc", "ld b,e", "ld c,d", "ld d,l", "ld e,h",\
                         _BCDE )

#endif /* __LIB_H__ */
