/*
 * Functions to start the ethernet system.
 *
 * (C) 2002 Compendium Technologies, Inc.
 * (C) 2002 Softools, Inc.
 * All rights reserved.
 *
 * This software is the proprietary information of Compendium Technologies, Inc.
 * and Softools, Inc. Use is subject to license terms.
 */
#include "rabbitlwip.h"
#include "lwipopts.h"
#include "lwip/mem.h"
#include "lwip/memp.h"
#include "lwip/pbuf.h"
#include "lwip/sys.h"
#ifdef STATS
#  include "lwip/stats.h"
#endif

unsigned char netInited = 0;

/**
 * Call this only once. It sets up the memory for the lwIP system.
 */
void netInit()
{
#ifdef STATS
    stats_init();
#endif
    sys_init();
    mem_init();
    memp_init();
    pbuf_init();
    netInited = 1;
}
