#include <stdio.h>
#include <string.h>
#include <Rabbit2000.h>
#include "rabbitlwip.h"
#include "lwip/api.h"


far void main(void)
{
    // Dummy configuration, will be overwritten by DHCP
    NetConfig config;
    NetConnectionConfig interface;
    int ethStatus;
    char MACString[20];
    int productID;

    WDT_DISABLE();

    // Clear the Softools WinIDE print buffer from any previous program runs
    printf("\x1A");
    productID = netRecognize();
    config.hostName = "test";
    config.domainName = "toman.org";
    //netStringToIP("192.168.10.1", &config.defaultGateway);
    netStringToIP("192.168.2.1", &config.defaultGateway);
    netConfigure(&config);

    // Start ethernet with DHCP using default handlers (will respond to
    // ICMP echo requests)
    printf("** Starting Ethernet Interface **\n");
    printf("Rabbit 2000 board or core module %s recognized\n",
           (productID ? "is" : "is not"));

    interface.connType = ETH_CONN;
    //netStringToIP("192.168.10.40", &interface.address);
    netStringToIP("192.168.2.40", &interface.address);
    netStringToIP("255.255.255.0", &interface.netmask);

    // Netmasks of the form 192.168.1.255 will fail!

    // Start timer up. This *must* be done or the TCP/IP stack may not
    // behave correctly.
    // Interrupt handler to process incoming packets runs at regular
    // intervals (in this case 50 times per second, which is every 20ms).
    // Note that the ethernet doesn't have to be started to run this timer.
    startTimer(50, netProcess, 2);
    ipset1();

    // Start ethernet interface
    //ethStatus = ethernetStart(NULL, NULL);
    ethStatus = ethernetStart(&interface, "192.168.10.2", NULL);
    //ethStatus = ethernetStart(&interface, "192.168.2.1", NULL);
    //ethStatus = ethernetStart(&interface, NULL);
    //printf("MAC: %s\n", netGetMAC(MACString));
    if (ethStatus == 3)
    {
        // DHCP failed, use fallback address
        printf("DHCP/BOOTP failed; no ip address\n");
        ethStatus = ethernetStart(&interface, NULL);
    }

    if (ethStatus != 0)
    {
        // Error code: ethernet initialization failed somehow
        printf("Got error code %d", ethStatus);
    }
    else
    {
        // Successful initialization
        char name[HOSTNAME_LENGTH];
        //longword address;
        //eth_address addr;

        printf("Ethernet initialization succeeded\n");
        printf("hostname: %s\n", netGetHostName());
        printf("domain: %s\n", netGetDomainName());
        printf("ip: %s\n", netIPToString(&interface.address, name));

        // Set up a server socket here

        {
            struct netconn *conn, *newconn;
            err_t err;

            /* Create a new connection identifier. */
            conn = netconn_new(NETCONN_TCP);
            printf("created new connection\n");

            /* Bind connection to well known port number 7. */
            netconn_bind(conn, NULL, 7);
            printf("bind to tcp port 7\n");

            /* Tell connection to go into listening mode. */
            netconn_listen(conn);
            printf("listening for connections\n");

            while (1)
            {

                /* Grab new connection. */
                newconn = netconn_accept(conn);
                printf("accepted new connection %p\n", newconn);
                /* Process the new connection. */
                if(newconn != NULL)
                {
                    struct netbuf *buf;
                    void *data;
                    u16_t len;

                    while ((buf = netconn_recv(newconn)) != NULL)
                    {
	                printf("Recved %s\n", buf);
	                do
                        {
	                    netbuf_data(buf, &data, &len);
	                    err = netconn_write(newconn, data, len,
                                                NETCONN_COPY);
	                    if(err != ERR_OK)
                            {
	                        //printf("tcpecho: netconn_write: error \"%s\"\n",
                                //       lwip_strerr(err));
                                printf("-");
	                    }
	                } while(netbuf_next(buf) >= 0);
	                netbuf_delete(buf);
                    }
                    printf("Got EOF, looping\n");
                    /* Close connection and discard connection identifier. */
                    netconn_delete(newconn);
                }
            }
        }
    }
}
